/*******************************
  srv.c

  R8C/27	74HC237(3ꍇ)
  ---------------------------
  P1		C		(1-3)
  P13(D)	G1,GL	(3)
  P14(C)	G1,GL	(2)
  P19(B)	G1,GL	(1)
  P23		A		(1-3)
  P24		B		(1-3)
  
 *******************************/
#include	"sfr_r827.h"				/* R8C/27 SFRi|[g`t@Cjǂݍ */
#include	"led.h"
#include	"srv.h"
#include	"uart1.h"
#include	"ad.h"

volatile unsigned char SRV_onoff_flag; // 1oCg
volatile unsigned char SRV_mode;
unsigned char Sidx;              // 1oCg
unsigned int  Stemp[3];                // 6oCg2oCg~3
                                      // 48oCg2oCg~24
unsigned int  Shome[3][8] ={{0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0}};
                                      // 48oCg2oCg~24
unsigned int  Snow[3][8]  ={{0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0}};
                                      // 48oCg2oCg~24
  signed int  Smove[3][8] ={{0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0},
                            {0,0,0,0,0,0,0,0}};

unsigned char  STEP;                  // 1oCg
unsigned char  CNT;                   // 1oCg

volatile unsigned char count;                     /* count of Timer RA interrupt */
                               
/*********************************
  T[{䃂W[̏
 *********************************/
void SRV_init(void)
{
    /* ϐ̏ */
	SRV_onoff_flag = 0;
	Sidx = 0;

    /* Select|[g̐ݒ */
	pd3_3 = 1;							/* |[gWX^ 0: 1:o */
	pd3_4 = 1;							/* |[gWX^ 0: 1:o */
	pd3_5 = 1;							/* |[gWX^ 0: 1:o */
    
    /* ^C}[RC̏ */
	pd1_2 = 1;							/* TRCIOB[qo͂(P1_2) |[gWX^ 0: 1:o */
	trciocsel = 0;						/* TRCIOC[qI(0:P5_3) */
	trciodsel = 0;						/* TRCIOD[qI(0:P5_4) */
	
	tstart_trcmr = 0;					/* ^C}RC~ */
	trcic = 0x00;						/* TRC荞݋֎~ */

	pwmb_trcmr = 1;			/* 1:PWM[h */
	pwmc_trcmr = 1;			/* 1:PWM[h */
	pwmd_trcmr = 1;			/* 1:PWM[h */
	pwm2_trcmr = 1;			/* 1:^C}[h܂PWM[h */
	bfc_trcmr = 0;			/* TRCGRCWX^:WFlWX^ */
	bfd_trcmr = 0;			/* TRCGRDWX^:WFlWX^ */
	
	/* TRCCR1WX^ݒ肵ƂAo̓xo͂܂B */
	tob_trccr1 = 1;			/* 1:TRCGRB̈vŁgLhATRCGRÄvŁgHhBgHhANeBu */
	toc_trccr1 = 1;			/* 1:TRCGRC̈vŁgLhATRCGRÄvŁgHhBgHhANeBu */
	tod_trccr1 = 1;			/* 1:TRCGRD̈vŁgLhATRCGRÄvŁgHhBgHhANeBu */
	
	ea_trcoer = 1;			/* 1:o͋֎~(TRCIOA[q̓vO}uo̓|[g) */
	eb_trcoer = 0;			/* 0:o͋ TRCIOBo */
	ec_trcoer = 0;			/* 0:o͋ TRCIOCo */
	ed_trcoer = 0;			/* 0:o͋ TRCIODo */
	pto_trcoer = 0;			/* pXo͋Ւf́iINT0j */

	tck0_trccr1 = 1;		/* 001:f2i2jJEg\[Xɐݒ */
	tck1_trccr1 = 0;
	tck2_trccr1 = 0;
	cclr_trccr1 = 1;		/* 1:TRCGRÃRyAvŃJE^NA */

	/* TRCGRAWX^TRCGRBWX^̃RyAvɔƁA
	   TRCGRBWX^̃RyAvDBTRCIOBo͂́gLhɂȂBȂ킿ωȂB */
	trcgra = PULSE_CYCLE;	/* pX */
	trcgrb = PULSE_CYCLE;
	trcgrc = PULSE_CYCLE;
	trcgrd = PULSE_CYCLE;
	
	imiea_trcier = 1;		/* 1: TRCGRÃRyAv荞 */
	imieb_trcier = 0;		/* 0:֎~ TRCGRB̃RyAv荞 */
	imiec_trcier = 0;		/* 0:֎~ TRCGRC̃RyAv荞 */
	imied_trcier = 0;		/* 0:֎~ TRCGRD̃RyAv荞 */
	trcic = 0x01;			/* 荞ݗD惌x1 */

	trc = 0;				/* ^C}RCJEgNA */
	tstart_trcmr = 1;		/* ^C}RCJn */
}

/**********************************
  ^C}RC }b`A荞
 **********************************/
#pragma interrupt	_timer_rc(vect=7)
void _timer_rc(void)
{

switch (SRV_mode) {

case 4:
	/* ړI̓pxۑ */
	Stemp[0] = Snow[0][Sidx] + Smove[0][Sidx];
	Stemp[1] = Snow[1][Sidx] + Smove[1][Sidx];
	Stemp[2] = Snow[2][Sidx] + Smove[2][Sidx];
		
	/* 20msł̓px߂āAf[eB[lۑ */
	Snow[0][Sidx] += (Smove[0][Sidx] / STEP);
	Snow[1][Sidx] += (Smove[1][Sidx] / STEP);
	Snow[2][Sidx] += (Smove[2][Sidx] / STEP);
	
	/* c̓pxۑ */
	Smove[0][Sidx] = Stemp[0] - Snow[0][Sidx];
	Smove[1][Sidx] = Stemp[1] - Snow[1][Sidx];
	Smove[2][Sidx] = Stemp[2] - Snow[2][Sidx];

case 3:
    /* 1STEPi8j삵STEP}CiXACNT0ɂ */
    CNT++;
    if(CNT >= 8){STEP--;CNT=0;}

    /* SẴT[{STEPISRV_modeύX */
	if(STEP == 0){SRV_mode=2;}
	
case 2:
	/* ͈͂𒴂Ă͈͓ɐݒ肵Ȃ */
	if(Snow[0][Sidx] < MIN_DUTY){Snow[0][Sidx] = MIN_DUTY;}
	if(Snow[1][Sidx] < MIN_DUTY){Snow[1][Sidx] = MIN_DUTY;}
	if(Snow[2][Sidx] < MIN_DUTY){Snow[2][Sidx] = MIN_DUTY;}
	
	if(Snow[0][Sidx] > MAX_DUTY){Snow[0][Sidx] = MAX_DUTY;}
	if(Snow[1][Sidx] > MAX_DUTY){Snow[1][Sidx] = MAX_DUTY;}
	if(Snow[2][Sidx] > MAX_DUTY){Snow[2][Sidx] = MAX_DUTY;}

	trcgrb = Snow[0][Sidx];
	trcgrc = Snow[1][Sidx];
	trcgrd = Snow[2][Sidx];

	break;
	
case 1:
    /* 1STEPi8j삵STEP}CiXACNT0ɂ */
    CNT++;
    if(CNT >= 8){STEP--;CNT=0;}

    /* SẴT[{STEPISRV_modeύX */
	if(STEP == 0){SRV_mode=0;}
	
case 0:
    if( trcgrb < trcgra ) while( trcgrb >= trc ); trcgrb = trcgra;
    if( trcgrc < trcgra ) while( trcgrc >= trc ); trcgrc = trcgra;
	if( trcgrd < trcgra ) while( trcgrd >= trc ); trcgrd = trcgra;	
	break;
}

	/* RyAvtOANA */
	imfa_trcsr = 0;
	
	/* CfbNX̍XV */
	Sidx++;
	if(Sidx >= 8) 
	{
		Sidx = 0;         			/* CfbNX8AȂ킿9ڈȏゾ0i1ځjɖ߂ */
		LED1 = ~LED1;				/* LED_TOGGLE */
	}
	
	/* ̃CfbNXZbg */
	p3 = (p3 & ~0b00111000) | Sidx << 3;
}

/**********************************
  move
 **********************************/
void move(signed int id00,signed int id01,signed int id02,signed int id03,
          signed int id04,signed int id05,signed int id06,signed int id07,
          signed int id10,signed int id11,signed int id12,signed int id13,
		  signed int id14,signed int id15,signed int id16,signed int id17,
          signed int id20,signed int id21,signed int id22,signed int id23,
		  signed int id24,signed int id25,signed int id26,signed int id27,unsigned char stp)
{
	STEP = stp;
	CNT = 0;

	/* ړI̊px猻݂̊pxēpx߂ */
	Smove[0][0] = (Shome[0][0] + id00) - Snow[0][0];
	Smove[0][1] = (Shome[0][1] + id01) - Snow[0][1];
	
	Smove[1][0] = (Shome[1][0] + id10) - Snow[1][0];
	Smove[1][1] = (Shome[1][1] + id11) - Snow[1][1];
	
	Smove[2][0] = (Shome[2][0] + id20) - Snow[2][0];
	Smove[2][1] = (Shome[2][1] + id21) - Snow[2][1];


	SRV_mode = 4;
	/* 荞ݓł̓삪I܂őҋ@ */
	while(SRV_mode==4);
}

/**********************************
  z[|WVֈړ
 **********************************/
void homemove(unsigned char stp)
{
   move(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,stp);
}

/**********************************
  z[|WVZbg
 **********************************/
void homeset(signed int id00,signed int id01,signed int id02,signed int id03,
             signed int id04,signed int id05,signed int id06,signed int id07,
             signed int id10,signed int id11,signed int id12,signed int id13,
		     signed int id14,signed int id15,signed int id16,signed int id17,
             signed int id20,signed int id21,signed int id22,signed int id23,
		     signed int id24,signed int id25,signed int id26,signed int id27)
{
	Snow[0][0] = Shome[0][0] = id00;
	Snow[0][1] = Shome[0][1] = id01;
	
	Snow[1][0] = Shome[1][0] = id10;
	Snow[1][1] = Shome[1][1] = id11;
	
	Snow[2][0] = Shome[2][0] = id20;
	Snow[2][1] = Shome[2][1] = id21;
}

/*********************************
  T[{Jn
 *********************************/
void SRV_on(void)
{
	/* o͋ */
	SRV_onoff_flag = 2;
    SRV_mode = 2;
}

/*********************************
  T[{~
 *********************************/
void SRV_off(void)
{
	/* o͋֎~ */
	SRV_onoff_flag = 0;
    SRV_mode = 0;
}

/**********************************
  wait
 **********************************/
void wait(unsigned char stp)
{
	STEP = stp;
	CNT = 0;
	
	if(SRV_onoff_flag == 0){SRV_mode=1;while(SRV_mode==1);}
	if(SRV_onoff_flag == 2){SRV_mode=3;while(SRV_mode==3);}
}