/*******************************
  uart1.c

  R8C/27	UART1
  ---------------------------
  P2		TXD1
  P9		RXD1
 *******************************/
#include	"sfr_r827.h"				/* R8C/27 SFRi|[g`t@Cjǂݍ */
#include	"uart1.h"

unsigned char RXbuff[10];
unsigned char RXid = 0;
unsigned char RXcnt = 0;
unsigned char v14,v15,v21,v22;

/*********************************
  VAʐMW[̏
 *********************************/
void UART1_init(void)
{
	pd4_5 = 0;							/* ̓|[g */
	int0en = 0;							/* INT0gp֎~ */
	uart1sel1 = 0;						/* [qIWX^1:P3_7(TXD1)AP4_5(RXD1) */
	uart1sel0 = 1;						/* な */
	u1pinsel = 1;						/* TXD1[q؂ւ */
	txd1sel = 1;						/* |[g/TXD1[q؂ւ */
	txd1en = 1;							/* TXD1/RXD1I */

	u1mr = 0x05;						/* 101FUART[h]f[^8rbg */
										/* NbN */
										/* 1Xgbvrbg */
										/* peB֎~ */
	
	u1c0 = 0x00;						/* BRGJEg\[X:"f1"Ȃ */
										/* TXD1[qCMOSo */
										/* LSBt@[Xg */
	
	u1c1 = 0x00;						/* M֎~ */
										/* M֎~ */
										/* M荞ݗvFMobt@ */
										/* AM[h֎~ */

	u1brg = 0x40;						/* 20MHz / f1 / (16 * (64 + 1)) = 19230.76923 */
	s1tic = 0x00;						/* M荞݋֎~ */
	s1ric = 0x01;						/* M荞݋ 荞ݗD惌x1 */
	te_u1c1 = 1;						/* M\ */
	re_u1c1 = 1;						/* M\ */
}

/**********************************
  M荞
  uintprg.cv̓RgAEg
 **********************************/
#pragma interrupt	_uart1_receive(vect=20)
void _uart1_receive(void)
{
	unsigned char rx1c;
	
	if(ri_u1c1 == 1){					/* Data in U1RB register ? */
		rx1c = u1rb;					/* Mf[^ */

		//if(rx1c==0x0d){break;}
		//if(rx1c==0x5b){trcgrb +=  10;}//[
		//if(rx1c==0x5d){trcgrb -=  10;}//]
		//if(rx1c==0x7b){trcgrb += 100;}//{
		//if(rx1c==0x7d){trcgrb -= 100;}//}

		RXbuff[RXid] = rx1c & 0xFF;			// Mf[^obt@ɏ

		RXcnt++;
		if(RXcnt < 5 || RXcnt > 14) RXid++; // Mf[^id5`14܂łSRAMߖ̂ߎ̂Ă

		if(RXbuff[0]!=0x23){RXid=0;RXcnt=0;}		
	
		if(RXcnt>19)
		{
			if(RXbuff[ 9]==0x0d)
			{
		
			v14 = ((RXbuff[ 1] & 0x0F) << 4) | (RXbuff[ 2] & 0x0F);//((RXbuff[ 1] - 0x30) * 16) + (RXbuff[ 2] - 0x30)
			v15 = ((RXbuff[ 3] & 0x0F) << 4) | (RXbuff[ 4] & 0x0F);
			v21 = ((RXbuff[ 5] & 0x0F) << 4) | (RXbuff[ 6] & 0x0F);		
			v22 = ((RXbuff[ 7] & 0x0F) << 4) | (RXbuff[ 8] & 0x0F);

			}
		RXid=0;RXcnt=0;
		}
	}
}



/*********************************
/************************************************************************/
/* Po                                                           */
/* @ Mf[^                                                    */
/* ߂l 0:M̂߁AMł 1:MZbg                   */
/************************************************************************/
int put_uart1( char r )
{
    if(ti_u1c1 == 1) {                  /* Mf[^ȂH             */
        u1tbl = r;
        return 1;
    } else {
        /* ɑM(̃f[^͑MɏI) */
        return 0;
    }
}

/************************************************************************/
/* o                                                           */
/* @ Mf[^                                                    */
/* ߂l                                                           */
/************************************************************************/
void put_uart1_str( char *str )
{
    while(*str != '\0') {
        /* '\n''\r\n'ɕϊ */
        if( *str == '\n' ) while( !put_uart1( '\r' ) );
        while( !put_uart1( *str ) );    /* 1M                    */
        str++;
    }
}

/************************************************************************/
/* 10io                                                           */
/* @ long l, int (1`8)                                         */
/* ߂l                                                           */
/************************************************************************/
void put_uart1_num( long value, int keta )
{
    int i = keta-1;
    long temp = 0;

    do {
        temp += value % 10;
        value /= 10;
        temp <<= 4;
    } while( --i );
    temp += value;

    do {
        while( !put_uart1( (temp & 0xf) + '0' ) );  /* 1M        */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* 16io                                                           */
/* @ unsigned long l, int (1`8)                                */
/* ߂l                                                           */
/************************************************************************/
void put_uart1_hex( unsigned long value, int keta )
{
    char temp;

    do {
        temp = value >> (keta * 4 - 4);
        temp &= 0x0f;
        temp += (temp < 10) ? '0' : ('a'-10);

        while( !put_uart1( temp ) );  /* 1M                  */
    } while( --keta );
}