/*******************************
  led.c

  R8C/27	LED
  ------------------
  P22		d
*******************************/
#include	"sfr_r827.h"				/* R8C/27 SFRi|[g`t@Cjǂݍ */
#include	"ad.h"

/*******************************
  A/DϊŎgp[q̏
*******************************/
void AD_init(void)
{
	prc2 = 1;							/* Protect off */
	pd0_7 = 0;					/* P25 AN0 |[gWX^ 0: 1:o */
	pd0_0 = 0;					/* P32 AN7 |[gWX^ 0: 1:o */
	pd1_0 = 0;					/* P22 AN8 |[gWX^ 0: 1:o */
	ki0en = 0;

    /* A/DRo[^̐ݒ */
	/* adcon0 */
    ch0 = 0;         /* b0 Analog input pin select bit   */
    ch1 = 0;         /* b1 Analog input pin select bit   */
    ch2 = 1;         /* b2 Analog input pin select bit   */
    md = 0;          /* b3 A-D operation mode select bit */
    adgsel0 = 1;     /* b4 A-D input group select bit    */
    adst = 0;        /* b6 A-D conversion start flag     */
    cks0_adcon0 = 1; /* b7 Frequency select bit0         */

	/* adcon1 */
    bits = 1;        /* b3 8/10-bit mode select bit      */
    cks1_adcon1	= 0; /* b4 Frequency select bit1         */
    vcut = 1;        /* b5 Vref connect bit              */
	
	//smp = 1;         /* Tvz[h */
	
	adic = 0x00;     /* Disable A-D conversion interrupt */

}

/************************************************************************/
/* P1_0(AN8)[qA/Dϊ                                               */
/* ߂l  A/Dϊl(0`1023)                                           */
/************************************************************************/
int get_ad8( void )
{
    int i;

	
    adst    = 0x01;                     /* A/DϊX^[g              */

    while(adst != 0);                   /* A/DϊI҂              */
    i = ad>>0;                            /* A/Dl擾(0`1023)           */

    return i;
}
